//
// Copyright (C) 2007-2016  Hideaki Takenaka, Hiroko Yamada
//
// Pick up Parameter in Particular Latitude Longitude 2015/08/10
// Modified for using Julidan day 2016/07/01
//

import java.io.*;
import java.util.*;
import java.text.DecimalFormat;
import java.util.Date;
import java.util.Calendar;

public class pickup
{

// Length of the Data in Column/Line Direction
static int X;
static int Y;

// Year/Month/Day/Hour/Minute
static int YYYY;
static int MM;
static int DD;
static int HH;
static int MN;

// UTC Year/Month/Day/Hour
static int UYYYY;
static int UMM;
static int UDD;
static int UHH;
static int UMN;

// Picked Pixel in X/Y Direction
static int Pick_Pix[] = new int[2+1];

// Time of Picked Data
static int Pick_Time_UTC[] = new int[6+1];
static int Pick_Time_Local[] = new int[6+1];

// Standard Latitude/Longitude Data
static float STN_LAT[][];
static float STN_LNG[][];

// Solar Zenith Angle
static double SZA;

// Use for Calculate SZA
static double a1 = 0.000075;
static double a2 = 0.001868;
static double a3 = 0.032077;
static double a4 = 0.014615;
static double a5 = 0.040849;

static double b1 = 0.006918;
static double b2 = 0.399912;
static double b3 = 0.070257;
static double b4 = 0.006758;
static double b5 = 0.000907;
static double b6 = 0.002697;
static double b7 = 0.001480;

// File Type
static String ftype;

// Time File Type
static String ttype;

// Directory Name to Read Original Data
static String input_DIR;

// Directory Name to Write Extract Parameter
static String Pickup_DIR;

// Directory Name to Read Standart Latitude/Longitude Data
static String SL_DIR;

// Filename of Standard Latitude
static String LATname;

// Filename of Standard Longitude
static String LNGname;

// Time Type
// TIME DIFF  & Time Type
static double TIME_DIFF; // int->doble for India 5.5H
static String TIME_Code;
// jd_UTC_PickUP
static double jd_UTC_PickUP;

public static void main(String args[])
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );

  // Filename to Write Extracted Data
  String wfilename;

  // Latitude/Longitude
  double LAT;
  double LNG;

  // Extracted parameter
  float Extract_param[] = new float[3+1];

  jday jday_jul_local = new jday();

  // Year/Month/Day/Hour/Minute
  //Input Time : local Time!!!  <--- UTC Time  // Specification Change　 h.yamada
  YYYY = Integer.valueOf(args[0]).intValue();
  MM   = Integer.valueOf(args[1]).intValue();
  DD   = Integer.valueOf(args[2]).intValue();
  HH   = Integer.valueOf(args[3]).intValue();
  MN   = Integer.valueOf(args[4]).intValue();

  LAT = Double.valueOf(args[5]).doubleValue();
  LNG = Double.valueOf(args[6]).doubleValue();

  //output/YYYYMM Dir confirm and create
  File newfile = new File("output/" + YYYY + df.format(MM));
   	if (newfile.exists()) {
    	System.out.println( newfile + " already exists");
	}else if (newfile.mkdir()){
    		System.out.println("Succeeded to create a directory");
  	}else{
    		System.out.println("Failed to create a directory");
  	}
	

  date_errorcheck();
  initialization();
  
  // Extract
  Extract_param[1] = (float)LAT;
  Extract_param[2] = (float)LNG;
  Extract_param[3] = extract(LAT, LNG); // extract  YYYY,MM,DD,HH... -> UTime
 
  wfilename = Pickup_DIR + YYYY + df.format(MM) + "/" + YYYY + df.format(MM) + df.format(DD) + df.format(HH) + df.format(MN) +"." + TIME_Code + ftype + ".pick.txt";

 // Calculation Pick_Time_local
    double jd_utctolocal = jd_UTC_PickUP + TIME_DIFF/24.0;
	Pick_Time_Local = jday_jul_local.jd2ymdhn(jd_utctolocal);

  System.out.println(STN_LAT[Pick_Pix[2]][Pick_Pix[1]] + " " + STN_LNG[Pick_Pix[2]][Pick_Pix[1]] + " " + Extract_param[3] + " " + Pick_Time_UTC[1] + " " + Pick_Time_UTC[2] + " " + Pick_Time_UTC[3] + " " + Pick_Time_UTC[4] + " " + Pick_Time_UTC[5] + " " + Pick_Time_UTC[6] + " UTC" );
  System.out.println(STN_LAT[Pick_Pix[2]][Pick_Pix[1]] + " " + STN_LNG[Pick_Pix[2]][Pick_Pix[1]] + " " + Extract_param[3] + " " + Pick_Time_Local[1] + " " + Pick_Time_Local[2] + " " + Pick_Time_Local[3] + " " + Pick_Time_Local[4] + " " + Pick_Time_Local[5] + " " + Pick_Time_Local[6] + " " + TIME_Code );

 // Write Extracted Data
  write_txt(wfilename, Extract_param);
  return;

}//main


public static float extract(double LAT, double LNG)
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );


  File file;

  // Answer
  float ANS;
  
  // Data Read
  float DR[][] = new float[Y+1][X+1];

  // Filename to Read Original Data
  String filename;


// UTC Time
    int UTime[] = new int[6+1];
    double jd_UTC = 0;
    jday jday_jul = new jday();
  
   	double jd_jul_ymdhn=(double)jday_jul.TransDateToJD(YYYY,MM,DD,HH,MN,15); //1.Seek the JD(Local Time)	
	
	jd_UTC= jd_jul_ymdhn - TIME_DIFF/24.0;	//  2.Seek the JD(UTC Time)
// 	System.out.println("jd_UTC: " + jd_UTC);

	UTime = jday_jul.jd2ymdhn(jd_UTC);//  3.JD(UTC Time) to Calendar (UYYYY,UMM,UDD,UHH,UMN)
//  System.out.println("UTime: " + UTime);
 
 
	 UYYYY = UTime[1];
      UMM = UTime[2];
      UDD = UTime[3];
      UHH = UTime[4];
      UMN = UTime[5];
 
  filename = input_DIR + UYYYY + df.format(UMM) + "/" + UYYYY + df.format(UMM) + df.format(UDD) + df.format(UHH) + df.format(UMN) + ftype;
 

  file = new File(filename);

  if(file.exists() == false)
  {
     System.out.println(filename + " is not found");
     System.exit(1);

  }//fi


  Pick_Pix = search_extract_pixel(LAT, LNG);
  
  time_check(LAT, LNG);
  
  bin bb = new bin();

  
  if(SZA < 90)
  {
    DR = bb.bin2f(filename, X, Y);
     ANS = (float)DR[Pick_Pix[2]][Pick_Pix[1]];
 
  }else{
  
    ANS = 0;
    
  }//fi
  

  return ANS;


}//extract


 public static int[] search_extract_pixel(double LAT, double LNG)
{

  int I,J;

  // Minimum Distance
  double MIN_DIS = 10000;

  // Disance of Column/Line Direction
  double DIS_X;
  double DIS_Y;

  // Minimum Distance Pixel Number of Column/Line Direction
  int MIN_X = 1;
  int MIN_Y = 1;

  // Pixel of the Answer in the X/Y Direction
  int ANS_Pixel[] = new int[2+1];
  
 //add sakashita
  double DIS_Border;
  
  if(X<Y)
  {
    DIS_Border = (STN_LNG[1][2]-STN_LNG[1][1])*1.5;
    
  }else{
  
    DIS_Border = (STN_LAT[1][1]-STN_LAT[2][1])*1.5;
    
  }//fi
  
  //add end

  for(I=1;I<=Y;I++)
  {
     for(J=1;J<=X;J++)
     {
        DIS_X = Math.pow(LNG - STN_LNG[I][J], 2);
        DIS_Y = Math.pow(LAT - STN_LAT[I][J], 2);

        if( Math.sqrt(DIS_X + DIS_Y) < MIN_DIS) 
        {
           MIN_DIS = Math.sqrt(DIS_X + DIS_Y);
           MIN_X = J;
           MIN_Y = I;

        }//fi
      }//J
  }//I
  
  
//  if(MIN_DIS > 0.1)
  if(MIN_DIS > DIS_Border)
  {
     System.out.println(LAT + ", " + LNG + " is out of range");
     System.exit(1);

  }//fi
  
  
  
  ANS_Pixel[1] = MIN_X;
  ANS_Pixel[2] = MIN_Y;
   
  return ANS_Pixel;
  
  
}//search_extract_pixel


 public static void time_check(double LAT, double LNG)
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );


  // Local Time
  int LTime[] = new int[5+1];

  // Local Year/Month/Day/Hour/Minute/Second
  float Time[][] = new float[Y+1][X+1];

  // Filename of Time Data
  String Timename;

   Timename = input_DIR + YYYY + df.format(UMM) + "/" + UYYYY + df.format(UMM) + df.format(UDD) + df.format(UHH) + df.format(UMN) + ttype;

  bin bb = new bin();

  Time = bb.bin2f(Timename, X, Y);
//     	System.out.println( "Time file "  + Time[Pick_Pix[2]][Pick_Pix[1]]);

   Pick_Time_UTC = mjd2utc(Time[Pick_Pix[2]][Pick_Pix[1]]);  // UTC Time  
   SZA = cal_sza(Pick_Time_UTC[1], Pick_Time_UTC[2], Pick_Time_UTC[3], Pick_Time_UTC[4], Pick_Time_UTC[5], (double)LAT, (double)LNG);
  
  if(SZA >= 90)
  {
    System.out.println("Solar Zenith Angle = " + SZA + " is more than 90 Degrees");
    //System.exit(1);
    
  }//fi

   return;
   
}//time_check


public static int[] mjd2utc(float Time)
{

  int I,J;

  int A;
  int B;

  // Modified Julian Day
  int MJD;
  double mjd;

  double jd;
  int aa;
  int bb;
  int cc;
  int ee;
  int ff;
  int gg;
  int hh;
  double ii;

  // Use for Calculate Year/Month/Day
  int Use_YYYY;
  int Use_MM;
  int Use_DD;

  // Picked Year/Month/Day/Hour/Minute/Second
  int PYYYY;
  int PMM;
  int PDD;
  int PHH;
  int PMN;
  int PSC;

  int UTC_Time[] = new int[6+1];


  if(MM==1 || MM==2)
  {
     Use_YYYY = YYYY-1;
     Use_MM   = MM+12;

  }else{

     Use_YYYY = YYYY;
     Use_MM = MM;

  }//fi

  Use_DD = DD;


  A = (int)(Use_YYYY/100);
  B = 2-A + (int)(A/4);

  MJD = (int)(Math.round((int)(365.25*(Use_YYYY+4716)) + (int)(30.6001*(Use_MM+1))+ Use_DD + B -1524.5)-2400000.5);
  mjd = MJD + (double)Time;

  jd = mjd + 2400000.5;
  jd_UTC_PickUP = jd;
  aa=(int)(jd+68569.5);
  bb=(int)(aa/36524.25);
  cc=aa-(int)(36524.25*bb+0.75);
  ee=(int)((cc+1)/365.25025);
  ff=cc-(int)(365.25*ee)+31;
  gg=(int)(ff/30.59);
  hh=(int)(gg/11);
  ii=jd+0.5-(int)(jd+0.5);

  PYYYY=100*(bb-49)+ee+hh;
  PMM=gg-12*hh+2;
  PDD=ff-(int)(30.59*gg);
  PHH=(int)(24*ii);
  PMN=(int)(1440*(ii-PHH/24.0));
  PSC=(int)(86400*(ii-PHH/24.0-PMN/1440.0));

  UTC_Time[1] = PYYYY;
  UTC_Time[2] = PMM;
  UTC_Time[3] = PDD;
  UTC_Time[4] = PHH;
  UTC_Time[5] = PMN;
  UTC_Time[6] = PSC;


  return UTC_Time;


}//mjd2utc


 public static int[] shift_time(int Year, int Month, int Day, int Hour, int Minute, double Shift_HH)
{

  // Shifted Year/Month/Day/Hour/Minute
  int Shift_Time[] = new int[5+1];

  Calendar time = Calendar.getInstance();

  time.set(Calendar.YEAR, Year);
  time.set(Calendar.MONTH, Month-1);
  time.set(Calendar.DAY_OF_MONTH, Day);
  time.set(Calendar.HOUR_OF_DAY, Hour);
  time.set(Calendar.MINUTE, Minute);

  // Shift Time
  time.add(Calendar.MINUTE, (int)Math.floor(Shift_HH*60));


  Shift_Time[1] = time.get(Calendar.YEAR);
  Shift_Time[2] = time.get(Calendar.MONTH) + 1;
  Shift_Time[3] = time.get(Calendar.DAY_OF_MONTH);
  Shift_Time[4] = time.get(Calendar.HOUR_OF_DAY);
  Shift_Time[5] = time.get(Calendar.MINUTE);


  return Shift_Time;


}//shift_time


public static int get_lastday(int Year, int Month)
{

  // Last Day of the Month
  int Last_DD;

  Calendar time = Calendar.getInstance();

  time.set(Calendar.YEAR, Year);
  time.set(Calendar.MONTH, Month-1);
  time.set(Calendar.DAY_OF_MONTH, 1);
  time.set(Calendar.HOUR_OF_DAY, 0);
  time.set(Calendar.MINUTE, 0);

  Last_DD = time.getActualMaximum(Calendar.DAY_OF_MONTH);


  return Last_DD;


}//get_lastday


public static int date2doy(int Year, int Month, int Day, int Hour, int Minute)
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );

  // Day of Year
  int DOY;

  Calendar time = Calendar.getInstance();

  time.set(Calendar.YEAR, Year);
  time.set(Calendar.MONTH, Month-1);
  time.set(Calendar.DAY_OF_MONTH, Day);
  time.set(Calendar.HOUR_OF_DAY, Hour);
  time.set(Calendar.MINUTE, Minute);


  DOY = time.get(Calendar.DAY_OF_YEAR);


  return DOY;


}//date2doy


public static double cal_sza(int Year, int Month, int Day, int Hour, int Minute, double LAT, double LNG)
{

  // Day of Year
  int DOY;
  
  // Local Time
  int Local_Time[] = new int[5+1];
  
  // Greenwith Meridian Time
  double UTC_Time;
  
  // Solar Declination
  double DEC;
  
  double A;
  double B;
  
  // Hour Angle
  double t;
  
  // Equation of Time
  double ET;
  
  // Mean Solar Time
  double MST;
  
  // True Solar Time
  double TST;
  
  // cos(Solar Zenith Angle)
  double SZA_cos;
  
  // Solar Zenith Angle
  double ANS;
  

  // Calculate HH + MN
  UTC_Time = Hour + (double)Minute / 60;
  
  // Calculate Local Time
  Local_Time = shift_time(Year, Month, Day, Hour, Minute, TIME_DIFF);

  // Calculate Day of Year
  DOY = date2doy(Local_Time[1], Local_Time[2], Local_Time[3], Local_Time[4], Local_Time[5]);

  LAT = Math.toRadians(LAT);
  

  A = (2*Math.PI*(DOY-1)) / 365;
  DEC = b1 - b2 * Math.cos(A) + b3 * Math.sin(A) - b4 * Math.cos(2*A) + b5 * Math.sin(2*A) - b6 * Math.cos(3*A) + b7 * Math.sin(3*A);
  
  B = (2*Math.PI*(DOY-1)) / 365;
  ET = ((a1 + a2 * Math.cos(B) - a3 * Math.sin(B) - a4 * Math.cos(2*B) - a5 * Math.sin(2*B))*12) / Math.PI;
  MST = UTC_Time + LNG / 15;
  TST = MST + ET;
  t = (15 * Math.PI/180)*(TST-12);
  
  
  SZA_cos = Math.cos(Math.PI/2 - DEC) * Math.cos(Math.PI/2 - LAT) + Math.sin(Math.PI/2 - DEC) * Math.sin(Math.PI/2 - LAT) * Math.cos(t);
  ANS = Math.toDegrees(Math.acos(SZA_cos));
  
  
  return ANS;
  
}//cal_sza


public static void date_errorcheck()
{

  DecimalFormat df = new DecimalFormat();
  df.applyLocalizedPattern( "00" );


  // Last Day of the Month
  int Last_DD;


  // Year Check
  if(YYYY <= 0)
  {
     System.out.println("Year " + YYYY + " is less than or equal to 0");
     System.exit(1);

  }//fi

  // Month Check
  if(MM <= 0 || MM > 12)
  {
     System.out.println("Month " + MM + " does not exist");
     System.exit(1);

  }//fi

  // Day Check
  Last_DD = get_lastday(YYYY, MM);

  if(DD > Last_DD || DD <= 0)
  {
     System.out.println("Date of " + YYYY + df.format(MM) + df.format(DD) + " does not exist");
     System.exit(1);

  }//fi

  // Hour Check
  if(HH < 0 || HH >= 24)
  {
     System.out.println("Hour " + HH + " does not exist");
     System.exit(1);

  }//fi

  // Minute Check
  if(MN < 0 || MN >= 60)
  {
     System.out.println("Minute " + MN + " does not exist");
     System.exit(1);

  }//fi


  return;


}//date_errorcheck
  

public static void initialization()
{
  read_formatfile();


  STN_LAT = new float[Y+1][X+1];
  STN_LNG = new float[Y+1][X+1];


  read_standard_latlng();


  return;


}//initialization


static public void read_formatfile()
{

  // Present Line
  int pline=1;

  String filename;
  String readline;
  String param[] = new String [100+1]; 


  filename = "config/format.txt";


  // Read Format File
  try
  {
       
    System.out.print(filename +"  Loading ...");

    BufferedReader br = new BufferedReader(new FileReader(filename));

    while( (readline = br.readLine()) != null ){

        StringTokenizer st = new StringTokenizer(readline);

        param[pline] =  st.nextToken(", ");

        pline++;
                 
    }//while

    br.close();
	
  }catch (IOException e){

      System.err.println("Initialize error\n");
      System.exit(1);

   }//try

  System.out.println(" finish");

  
  TIME_DIFF = Double.valueOf(param[1]).doubleValue();
  TIME_Code = param[2];
  X = Integer.valueOf(param[3]).intValue();
  Y = Integer.valueOf(param[4]).intValue();

  ftype = param[5];
  ttype = param[10];

  input_DIR = param[6];
  Pickup_DIR = param[7];
  SL_DIR = "config/";

  LATname = param[8];
  LNGname = param[9];

  return;


}//read_formatfile


public static void read_standard_latlng()
{
  // Filename of Latitude/Longitude Data
  String lat_filename;
  String lng_filename;

  lat_filename = SL_DIR + LATname;
  lng_filename = SL_DIR + LNGname;


  bin bb = new bin();

  STN_LAT = bb.bin2f(lat_filename, X, Y);
  STN_LNG = bb.bin2f(lng_filename, X, Y);

  return;


}//read_standard_latlng



static public void write_txt(String filename, float Extract[])
{


  int I,J;

  try{


     System.out.print(filename +"  Writing ...");
     PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(filename)));

//     pw.print(Extract[1] + " " + Extract[2] + " " + STN_LAT[Pick_Pix[2]][Pick_Pix[1]] + " " + STN_LNG[Pick_Pix[2]][Pick_Pix[1]] + " " + Extract[3] + " " + Pick_Time_UTC[1] + " " + Pick_Time_UTC[2] + " " + Pick_Time_UTC[3] + " " + Pick_Time_UTC[4] + " " + Pick_Time_UTC[5] + " " + Pick_Time_UTC[6] + " UTC");
//	 pw.println();
	 pw.write(Extract[1] + " " + Extract[2] + " " + STN_LAT[Pick_Pix[2]][Pick_Pix[1]] + " " + STN_LNG[Pick_Pix[2]][Pick_Pix[1]] + " " + Extract[3] + " " + Pick_Time_Local[1] + " " + Pick_Time_Local[2] + " " + Pick_Time_Local[3] + " " + Pick_Time_Local[4] + " " + Pick_Time_Local[5] + " " + Pick_Time_Local[6]  + " " + TIME_Code );
	 pw.println();
     pw.close();
		

  }catch(IOException e){

      System.err.println(filename + " write error\n");  
      System.exit(1);
   }

   System.out.println(" finish");


   return;

}//write_txt


}//EOF



